<!DOCTYPE html>
<html>
  <head>
    <title>Donkey Cars - 101</title>
    <meta charset="utf-8">

    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/reveal.js/3.6.0/css/reveal.css">
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/reveal.js/3.6.0/css/theme/white.css">
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/styles/arduino-light.min.css">
    <link rel="stylesheet" href="https://cdnjs.cloudflare.com/ajax/libs/font-awesome/5.8.2/css/all.min.css">

    <script src="https://cdnjs.cloudflare.com/ajax/libs/jquery/3.4.1/jquery.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/clipboard.js/2.0.4/clipboard.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/reveal.js/3.6.0/lib/js/head.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/reveal.js/3.6.0/js/reveal.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/highlight.min.js"></script>
    <script src="https://cdnjs.cloudflare.com/ajax/libs/highlight.js/9.12.0/languages/arduino.min.js"></script>

    <style>
      @import url(https://fonts.googleapis.com/css?family=Open+Sans+Condensed:300,700);
      @import url(https://fonts.googleapis.com/css?family=Open+Sans:400,700,400italic);
      @import url(https://fonts.googleapis.com/css?family=Ubuntu+Mono:400,700,400italic);

      body { font-family: 'Open Sans'; }

      .reveal { font-size: 28px; }
      .reveal .slides section { text-align: left; }
      .reveal .slides section.title { padding-top: 20%; text-align: center; }

      .reveal .slides::before {
        background-image: url(https://ballarathackerspace.org.au/images/bhack-logo-title-black.svg);
        background-repeat: no-repeat;
        background-size: contain;
        bottom: 8px;
        content: '';
        height: 32px;
        left: 8px;
        position: absolute;
        width: 128px;
      }

      .reveal h1, .reveal h2, .reveal h3 { font-family: 'Open Sans Condensed'; font-weight: 700; }

      .reveal pre {
        border: 1px solid #ccc;
        box-shadow: 0px 0px 6px rgba(0, 0, 0, 0.1);
        margin: 20px 0;
        padding: 4px 0;
        width: 100%;
      }

      .reveal code { font-family: 'Ubuntu Mono'; }
      .reveal pre code { padding: 0; margin: 8px; }
      .reveal blockquote { box-shadow: none; padding: 8px; width: 80%; }

      .feature-image,
      .full-image { text-align: center; }

      .feature-image img { max-height: 256px; }

      .full-image img { max-height: 512px; margin-top: 48px; }

      .sponsors { margin-top: 96px!important; text-align: center; }
      .sponsors img { max-height: 64px; }
      .sponsors img+img { margin-left: 16px; }

      .reveal ol, .reveal dl, .reveal ul { margin: 0 0 0 2em; }
      .reveal p, .reveal li { text-align: justify; }
      .reveal section img { border: none; box-shadow: none; }

      .btn {
        background-color: transparent;
        border: 1px solid #f0f0f0;
        color: #000;
        outline: 0;
        padding: 4px 8px;
        cursor: pointer;
      }

      .btn:active {
        background-color: #ddd !important;
      }

      .btn:hover {
        background-color: #eee;
        border: 1px solid #ddd;
      }

      .btn-copy {
        float: right;
      }
    </style>
  </head>
  <body>
    <div class="reveal">
      <div class="slides">

    <!-- 010-title.md -->
    <section class="title">
      <h1>Donkey Cars – 101</h1>
<h3>An AI/ML Workshop</h3>
<div class="sponsors">
</div>


    </section>
    <!-- 120-welcome.md -->
    <section class="title">
      <h1>Welcome</h1>


    </section>
    <!-- 140-introduction.md -->
    <section class="">
      <h2>Introduction</h2>
<p>This workshop will walk you through an introduction of Artificial Intelligence and Machine Learning concepts and provide a practial hands on experience with a scale model self driving car.</p>
<p>You will learn:</p>
<ul>
<li>Foundation elements of Artificial Intelligence and Machine Learning.</li>
<li>Foundation elements of the Donkey Car project.</li>
<li>How to collect data for machine learning processsing.</li>
<li>How to train your own neural net.</li>
<li>How to iterate and improve on your neural nets.</li>
</ul>


    </section>
    <section>
        <!-- 150-ai-title.md -->
        <section class="title">
          <h1>ARTIFICAL INTELLIGENCE</h1>



        </section>
        <!-- 151-what-is-ai.md -->
        <section class="">
          <h2>What is Artificial Intelligence?</h2>
<p>Development in the field of technology has enhanced exponentially over the years. Over this time, we get terms like:</p>
<ul>
<li>Artificial Intelligence</li>
<li>Machine Learning</li>
<li>Deep Learning</li>
</ul>
<p>These terms are often confused; conflated or defined similarly.</p>



        </section>
        <!-- 152-ai-graph.md -->
        <section class="">
          <div class="full-image">
  <img src="./img/ai-concepts.png" />
</div>



        </section>
        <!-- 153-what-is-ai.md -->
        <section class="">
          <h3>Artifical Intelligence</h3>
<p>Artificial Intelligence (AI) describes machines that can perform tasks resembling those of humans.</p>
<blockquote>
<p>&quot;The ability of machines to work and think, like the human brain.&quot;</p>
</blockquote>
<p>AI implies machines that artificially model human intelligence.</p>
<p>AI systems help us manage, model, and analyse complex systems.</p>



        </section>
        <!-- 154-what-is-ml.md -->
        <section class="">
          <h3>Machine Learning</h3>
<p>Machine learning (ML) essentially is a building block for AI.</p>
<p>By doing ML, you are teaching a machine to learn how to perform a task, such as:</p>
<ul>
<li>image recognition,</li>
<li>recommender systems, and</li>
<li>fraud detection.</li>
</ul>
<p>Common examples of this phenomenon are virtual personal assistants, refined search engine results, image recognition, and product recommendations.</p>



        </section>
        <!-- 155-what-is-dl.md -->
        <section class="">
          <h3>Deep Learning</h3>
<p>Deep Learning (DL) is an approach to ML; one that focuses on learning data representations rather than on task-specific algorithms.</p>
<p>Makes use of Deep Neural Networks, which are inspired by the structure and function of the human brain.</p>
<p>Such networks are made of a huge number of layers (hence, their name) where data transforms through multiple layers before producing the output.</p>
<p>DL is used for purposes like Natural Language Processing (NLP), drug discovery and toxicology, bioinformatics, and many more.</p>



        </section>
    </section>

    <section>
        <!-- 170-ml-title.md -->
        <section class="title">
          <h1>MACHINE LEARNING</h1>



        </section>
        <!-- 171-ml-overview.md -->
        <section class="">
          <h2>Machine Learning</h2>
<p>Machine Learning is concerned with giving machines the ability to learn by training algorithms on a huge amount of data. It makes use of algorithms and statistical models to perform a task without needing explicit instructions.</p>
<p>There are three main types of ML:</p>
<ul>
<li>Supervised and semi-supervised learning</li>
<li>Unsupervised learning</li>
<li>Reinforcement learning</li>
</ul>



        </section>
        <!-- 172-ml-graph.md -->
        <section class="">
          <h2>Machine Learning Overview</h2>
<div class="full-image">
  <img src="./img/ml-overview.png" />
</div>



        </section>
        <!-- 174-ml-supervised.md -->
        <section class="">
          <h2>Supervised Learning</h2>
<p>Supervised learning typically begins with an established set of data and a certain understanding of how that data is classified.</p>
<p>Supervised learning is intended to find patterns in data that can be applied to an analytics process.</p>
<p>This data has labeled features that define the meaning of data. For example, you can create a machine-learning application that distinguishes between millions of animals, based on images and written descriptions.</p>



        </section>
        <!-- 175-ml-supervised-graph.md -->
        <section class="">
          <h2>Supervised Machine Learning</h2>
<div class="full-image">
  <img src="./img/ml-supervised.png" />
</div>



        </section>
        <!-- 176-ml-unsupervised.md -->
        <section class="">
          <h2>Unsupervised Learning</h2>
<p>Used when the problem requires a massive amount of unlabeled data. For example, social media applications, such as Twitter, Instagram and Snapchat, all have large amounts of unlabeled data.</p>
<p>Understanding the meaning behind this data requires algorithms that classify the data based on the patterns or clusters it finds.</p>
<p>Unsupervised learning conducts an iterative process, analysing data without human intervention.</p>
<p>For example, it is used within email spam-detecting technology. There are far too many variables in legitimate and spam emails for an analyst to be able tag unsolicited bulk email. Instead, machine learning classifiers, based on clustering and association, are applied to identify unwanted email.</p>



        </section>
        <!-- 177-ml-unsupervised-graph.md -->
        <section class="">
          <h2>Unsupervised Machine Learning</h2>
<div class="full-image">
  <img src="./img/ml-unsupervised.png" />
</div>



        </section>
        <!-- 178-ml-reinforment.md -->
        <section class="">
          <h2>Reinforcement Learning</h2>
<p>Reinforcement learning is a behavioral learning model.</p>
<p>The algorithm receives feedback from the data analysis, guiding the user to the best outcome.</p>
<p>Reinforcement learning differs from other types of supervised learning, because the system isn't trained with the sample data set. Rather, the system learns through trial and error. Therefore, a sequence of successful decisions will result in the process being reinforced, because it best solves the problem at hand.</p>



        </section>
        <!-- 179-ml-reinfocement-graph.md -->
        <section class="">
          <h2>Reinforcement Machine Learning</h2>
<div class="full-image">
  <img src="./img/ml-reinforcement.png" />
</div>



        </section>
    </section>

    <section>
        <!-- 300-dk-title.md -->
        <section class="title">
          <h1>DONKEY CAR</h1>



        </section>
        <!-- 301-dk-graph.md -->
        <section class="">
          <div class="full-image">
  <img src="./img/donkey-car.jpg" />
</div>



        </section>
        <!-- 302-dk-overview.md -->
        <section class="">
          <h2>What is a Donkey Car</h2>
<p>&quot;Donkey&quot; is a high level self driving library written in Python. It was developed with a focus on enabling fast experimentation and easy contribution.</p>
<p>A &quot;Donkey Car&quot; is an autonomous capable vehicle that utilised the &quot;Donkey&quot; software ecosystem.</p>



        </section>
        <!-- 303-dk-hardware-architecture.md -->
        <section class="">
          <h2>Hardware Architecture</h2>
<div class="full-image">
  <img src="./img/donkey-car-hardware-architecture.png" />
</div>



        </section>
        <!-- 304-dk-software-goal.md -->
        <section class="">
          <h2>Software Goal</h2>
<div class="full-image">
  <img src="./img/donkey-car-software-goal.png" />
</div>



        </section>
        <!-- 305-dk-software-architecture.md -->
        <section class="">
          <h2>Software Architecture</h2>
<div class="full-image">
  <img src="./img/donkey-car-software-architecture.png" />
</div>
<p>Run the &quot;vehicle loop&quot; 30 times per second.</p>



        </section>
        <!-- 310-dk-start-driving.md -->
        <section class="">
          <h2>Let's Get Driving</h2>
<ol>
<li>Boot up the car.</li>
<li>SSH to donkey-colour.local</li>
<li>python ~/mycar/manage.py drive</li>
<li>Browse to donkey-colour.local:8887</li>
</ol>
<div class="full-image">
  <img src="./img/donkey-car-start-driving.png" />
</div>



        </section>
        <!-- 311-dk-get-data.md -->
        <section class="">
          <h2>Collect Training Data</h2>
<div class="full-image">
  <img src="./img/donkey-car-collect-data.png" />
</div>



        </section>
        <!-- 315-dk-train-model.md -->
        <section class="">
          <h2>Train Your Model</h2>
<ol>
<li>Copy tub data from the car to the training computer.</li>
<li>python ~/mycar/manage.py train --tub &lt;tub folder names comma separated&gt; --model mypilot.h5</li>
<li>Copy model back the car.</li>
<li>python ~/mycar/manage.py drive --model ~/models/mypilot.h5</li>
</ol>



        </section>
        <!-- 320-dk-clean-data.md -->
        <section class="">
          <h2>Clean Your Model</h2>
<ol>
<li>donkey tubclean --tub ~/mycar/data</li>
</ol>
<div class="full-image">
  <img src="./img/donkey-car-clean-data.png" />
</div>



        </section>
        <!-- 320-donkey-car-test-drive-repeat.md -->
        <section class="">
          <h2>Test. Drive. Repeat.</h2>
<div class="full-image">
  <img src="./img/donkey-car-test-drive-repeat.png" />
</div>



        </section>
        <!-- 350-donkey-car-nn-overview.md -->
        <section class="">
          <h2>Neural Net Overview</h2>
<pre><code class="language-python">img_in = Input(shape=(120,160,3), name='img_in')
x = img_in
x = Convolution2D(24, (5,5), strides=(2,2), activation='relu')(x)
x = Convolution2D(32, (5,5), strides=(2,2), activation='relu')(x)
x = Convolution2D(64, (5,5), strides=(2,2), activation='relu')(x)
x = Convolution2D(64, (3,3), strides=(2,2), activation='relu')(x)
x = Convolution2D(64, (3,3), strides=(1,1), activation='relu')(x)

x = Flatten(name='flattened')(x)

x = Dense(100, activation='relu')(x)
x = Dropout(.1)(x)
x = Dense(50, activation='relu')(x)
x = Dropout(.1)(x)

# categorical output of the angle
angle_out = Dense(15, activation='softmax', name='angle_out')(x)

# continuous output of the throttle
throttle_out = Dense(1, activation='softmax', name='throttle_out')(x)
</code></pre>



        </section>
        <!-- 351-donkey-car-nn-graph.md -->
        <section class="">
          <h2>Neural Net Overview</h2>
<div class="full-image">
  <img src="./img/donkey-car-nn-overview.png" />
</div>



        </section>
    </section>

    <section>
        <!-- 900-where-to-next.md -->
        <section class="title">
          <h1>Where to next?</h1>



        </section>
        <!-- 901-additional-data.md -->
        <section class="">
          <h2>Additional Data</h2>
<div class="full-image">
  <img src="./img/donkey-car-additional-data.png" />
</div>



        </section>
        <!-- 902-new-environments.md -->
        <section class="">
          <h2>New Environments</h2>
<div class="full-image">
  <img src="./img/donkey-car-new-environments.png" />
</div>



        </section>
        <!-- 903-better-autopilots.md -->
        <section class="">
          <h2>Better Autopilots</h2>
<div class="full-image">
  <img src="./img/donkey-car-better-autopilots.png" />
</div>



        </section>
    </section>

    <section>
        <!-- 940-further-help.md -->
        <section class="title">
          <h1>Further Help</h1>



        </section>
        <!-- 941-further-help.md -->
        <section class="">
          <h2>Resources</h2>
<p>The Donkey Car project.</p>
<ul>
<li><a href="https://donkeycar.com">Website</a></li>
<li><a href="https://docs.donkeycar.com">Documentation</a></li>
<li><a href="https://github.com/autorope/donkeycar">Code Repository</a></li>
</ul>
<p>The Ballarat Hackerspace</p>
<ul>
<li>Open Mondays, Tuesdays, Wednesdays and Saturdays.</li>
<li>See <a href="https://ballarathackerspace.org.au">website</a> for details.</li>
</ul>



        </section>
    </section>

    <!-- 950-questions.md -->
    <section class="title">
      <h1>Questions?</h1>


    </section>

      </div>
    </div>
    <script>
      Reveal.initialize({
        center: false,
        fragments: true,
        fragmentInURL: true,
        history: true,
        transition: 'concave',
      });

      hljs.initHighlightingOnLoad();


      $(document).ready(function() {
        $('pre > code').each(function() {
          var e = $(this);
          e.prepend('<button class="btn btn-copy"><i class="fas fa-copy"></i></button>');
        });

        var clipboard = new ClipboardJS('.btn-copy', {
          text: function(trigger) {
            return $(trigger).parent().text();
          }
        });
        clipboard.on('success', function(e) {
          console.log(e.text);
        });
      });
    </script>
  </body>
</html>
